"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodePathCheck = function (_a) {
    var nodePath = _a.nodePath, separator = _a.separator;
    var pathIsValidString = typeof nodePath === "string" && nodePath.length;
    if (!pathIsValidString) {
        return { isFirstLevelNode: false, isValidPath: false };
    }
    var pathIsNotSolid = /\s/.test(nodePath);
    if (pathIsNotSolid) {
        return { isFirstLevelNode: false, isValidPath: false };
    }
    var pathIncludesSeparator = nodePath.includes(separator);
    if (!pathIncludesSeparator) {
        return { isFirstLevelNode: true, isValidPath: true };
    }
    var separatorIsInCorrectPlace = !nodePath.startsWith(separator) && !nodePath.endsWith(separator);
    if (!separatorIsInCorrectPlace) {
        return { isFirstLevelNode: false, isValidPath: false };
    }
    return { isFirstLevelNode: false, isValidPath: true };
};
