"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (function (_a) {
    var isObject = _a.isObject, nodePathSeparator = _a.nodePathSeparator, nodePathCheck = _a.nodePathCheck, invalidNodePathMessage = _a.invalidNodePathMessage, nonExistingNodeAccessMessage = _a.nonExistingNodeAccessMessage;
    return function (_a) {
        var nodePath = _a.nodePath;
        return function (source) {
            var _a = nodePathCheck({
                nodePath: nodePath,
                separator: nodePathSeparator
            }), isFirstLevelNode = _a.isFirstLevelNode, isValidPath = _a.isValidPath;
            if (!isValidPath) {
                var errorMessage = invalidNodePathMessage(nodePath);
                throw new Error(errorMessage);
            }
            var sourceAsObject = source;
            if (isFirstLevelNode) {
                return sourceAsObject[nodePath];
            }
            var nodePathAsArray = nodePath.split(nodePathSeparator);
            var lastNode = nodePathAsArray.pop();
            var firstNode = nodePathAsArray.shift();
            var nodeValue = sourceAsObject[firstNode] || {};
            for (var _i = 0, nodePathAsArray_1 = nodePathAsArray; _i < nodePathAsArray_1.length; _i++) {
                var currentPathPart = nodePathAsArray_1[_i];
                var _b = nodeValue, _c = currentPathPart, nextLevelPointer = _b[_c];
                nodeValue = nextLevelPointer;
                if (!isObject(nodeValue)) {
                    throw new Error(nonExistingNodeAccessMessage(currentPathPart));
                }
            }
            var _d = nodeValue, _e = lastNode, lastNodeValue = _d[_e];
            return lastNodeValue;
        };
    };
});
