"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (function (_a) {
    var nodePathSeparator = _a.nodePathSeparator, updateWithPattern = _a.updateWithPattern, isObject = _a.isObject, nodePathCheck = _a.nodePathCheck;
    return function (_a) {
        var _b;
        var nodePath = _a.nodePath, calcField = _a.calcField;
        var _c = nodePathCheck({
            nodePath: nodePath,
            separator: nodePathSeparator
        }), isFirstLevelNode = _c.isFirstLevelNode, isValidPath = _c.isValidPath;
        if (!isValidPath) {
            throw new Error("Not valid node path");
        }
        var nodePathAsArray = nodePath.split(nodePathSeparator);
        var updatingPatternTargetField = nodePathAsArray.pop();
        var finalUpdate = updateWithPattern({
            pattern: (_b = {},
                _b[updatingPatternTargetField] = calcField,
                _b)
        });
        if (isFirstLevelNode) {
            return function (source) {
                var sourceAsObject = source;
                var clone = __assign({}, sourceAsObject);
                return finalUpdate(clone);
            };
        }
        var lastNode = nodePathAsArray.pop();
        var copyField = function (_a) {
            var calcFieldToBeAppliedOnCopy = _a.calcFieldToBeAppliedOnCopy, copyObjectPointer = _a.copyObjectPointer, field = _a.field, sourceObjectPointer = _a.sourceObjectPointer;
            var _b = sourceObjectPointer, _c = field, targetNodeValue = _b[_c];
            var targetNodeIsObject = isObject(sourceObjectPointer[field]);
            var copy = targetNodeIsObject ? __assign({}, targetNodeValue) : {};
            copyObjectPointer[field] = calcFieldToBeAppliedOnCopy(copy);
        };
        return function (source) {
            var sourceAsObject = source;
            var clone = __assign({}, sourceAsObject);
            var copiedNodePointer = clone;
            var copyingNodePointer = sourceAsObject;
            for (var _i = 0, nodePathAsArray_1 = nodePathAsArray; _i < nodePathAsArray_1.length; _i++) {
                var field = nodePathAsArray_1[_i];
                copyField({
                    calcFieldToBeAppliedOnCopy: function (x) { return x; },
                    copyObjectPointer: copiedNodePointer,
                    field: field,
                    sourceObjectPointer: copyingNodePointer
                });
                var _a = copiedNodePointer, _b = field, nextLevelCopyPointer = _a[_b];
                copiedNodePointer = nextLevelCopyPointer;
                if (isObject(copyingNodePointer[field])) {
                    var _c = copyingNodePointer, _d = field, nextLevelSourcePointer = _c[_d];
                    copyingNodePointer = nextLevelSourcePointer;
                }
            }
            copyField({
                calcFieldToBeAppliedOnCopy: finalUpdate,
                copyObjectPointer: copiedNodePointer,
                field: lastNode,
                sourceObjectPointer: copyingNodePointer
            });
            return clone;
        };
    };
});
